<?php

/*******************************************
 *                                         *
 *     Filmverwaltung mit PHP & MySQL      *
 *                                         *
 *******************************************
 *                                         *
 * Copyright: ab 2005 Dominik Erdmann      *
 *  Internet: www.der-domi.de              *
 *     Email: kontakt@der-domi.de          *
 *                                         *
 *******************************************
 *                                         *
 * Das Skript darf nach eigenem Belieben   *
 * gendert werden. Copyright-Hinweise und *
 * Links auf www.der-domi.de drfen nicht  *
 * verndert werden und mssen jederzeit   *
 * sichtbar bleiben!                       *
 *                                         *
 *******************************************
 */

/*
 * Startseite
 */


if ( $_SESSION['UserRechte'] < 300 )
    exit();

if ( $myVar->MenuID == 287 && $_SESSION['UserRechte'] > 0 )
{
    if ( $settings->anzTopFilme )
    {
        echo "<h2 style=\"padding-left:2em\">Topfilme</h2>";

        // passenden Query finden
        $sql = "SELECT co.FILME_FilmID, FilmID, Titel, co.Rang, Appendix, Extension FROM $myDB->FILME fi " .
                "INNER JOIN $myDB->COVERS co ON co.FILME_FilmID=fi.FilmID ";
        if ( $myVar->GenreID != 0 )
            $sql .= " INNER JOIN $myDB->FILME_GENRES fg ON fi.FilmID = fg.FILME_FilmID AND fg.GENRES_GenreID = $myVar->GenreID";
        if (  $myVar->FormatID != 0 )
            $sql .= " INNER JOIN $myDB->FORMATE ON fi.FORMATE_FormatID = FormatID AND FormatID = $myVar->FormatID";
        if (  $myVar->CollectID != 0 )
            $sql .= " INNER JOIN $myDB->COLLECT ON fi.COLLECT_CollectID = CollectID AND CollectID = $myVar->CollectID";
        if (  $myVar->AudioID != 0 )
            $sql .= " INNER JOIN $myDB->AUDIO ON fi.AUDIO_AudioID = AudioID AND AudioID = $myVar->AudioID";


        $sql .= " WHERE istTopfilm=1 AND hatThumbnail=1 AND " . $myDB->sqlForPriv;
        $sql .= " ORDER BY Titel ASC LIMIT $settings->anzTopFilme";
        
        $rs = $myDB->go($sql);
        for ( $i=0; $row = $myDB->getRow($rs); ++$i )
        {
            $vars = array();
            $vars['MenuID'] = 280;
            $vars['FilmID'] = $row['FilmID'];
            $vars = $myVar->getRequest($vars);
            
            echo "<a style=\"border:0;border-color:white\" title=\"{$row['Titel']}\" class=\"filmThumb\" href=\"{$_SERVER['PHP_SELF']}?$vars\">";
            echo "<img src=\"$cover_dir/{$row['FILME_FilmID']}_{$row['Rang']}_{$row['Appendix']}_small.{$row['Extension']}\" alt=\"cover\" title=\"{$row['Titel']}\" />";
            echo "</a>";
        }
        echo "<div style=\"margin:2em\"></div>";
    }
    
    
    if ( $settings->anzNeueFilme )
    {
        echo "<h2 style=\"padding-left:2em\">neusten Filme</h2>";

        // passenden Query finden
        $sql = "SELECT co.FILME_FilmID, FilmID, Titel, co.Rang, Appendix, Extension FROM $myDB->FILME fi " .
                "INNER JOIN $myDB->COVERS co ON co.FILME_FilmID=fi.FilmID ";
        if ( $myVar->GenreID != 0 )
            $sql .= " INNER JOIN $myDB->FILME_GENRES fg ON fi.FilmID = fg.FILME_FilmID AND fg.GENRES_GenreID = $myVar->GenreID";
        if (  $myVar->FormatID != 0 )
            $sql .= " INNER JOIN $myDB->FORMATE ON fi.FORMATE_FormatID = FormatID AND FormatID = $myVar->FormatID";
        if (  $myVar->CollectID != 0 )
            $sql .= " INNER JOIN $myDB->COLLECT ON fi.COLLECT_CollectID = CollectID AND CollectID = $myVar->CollectID";
        if (  $myVar->AudioID != 0 )
            $sql .= " INNER JOIN $myDB->AUDIO ON fi.AUDIO_AudioID = AudioID AND AudioID = $myVar->AudioID";

        $sql .= " WHERE hatThumbnail=1 AND " . $myDB->sqlForPriv;
        $sql .= " ORDER BY inserted DESC, FilmID DESC LIMIT $settings->anzNeueFilme";
        
        $rs = $myDB->go($sql);
        for ( $i=0; $row = $myDB->getRow($rs); ++$i )
        {
            $vars = array();
            $vars['MenuID'] = 280;
            $vars['FilmID'] = $row['FilmID'];
            $vars = $myVar->getRequest($vars);
            
            echo "<a title=\"{$row['Titel']}\" class=\"filmThumb\" href=\"{$_SERVER['PHP_SELF']}?$vars\">";
            echo "<img src=\"$cover_dir/{$row['FILME_FilmID']}_{$row['Rang']}_{$row['Appendix']}_small.{$row['Extension']}\" alt=\"cover\" title=\"{$row['Titel']}\" />";
            echo "</a>";
        }
        echo "<div style=\"margin:2em\"></div>";
    }
    
    
    if ( $settings->anzBestFilme )
    {
        echo "<h2 style=\"padding-left:2em\">beste Bewertung der Filme</h2>";

        // passenden Query finden
        $sql = "SELECT co.FILME_FilmID, FilmID, Titel, co.Rang, Appendix, Extension FROM $myDB->FILME fi " .
                "INNER JOIN $myDB->COVERS co ON co.FILME_FilmID=fi.FilmID " .
                "INNER JOIN $myDB->FILME_USERS fu ON fu.FILME_FilmID=fi.FilmID ";
        if ( $myVar->GenreID != 0 )
            $sql .= " INNER JOIN $myDB->FILME_GENRES fg ON fi.FilmID = fg.FILME_FilmID AND fg.GENRES_GenreID = $myVar->GenreID";
        if (  $myVar->FormatID != 0 )
            $sql .= " INNER JOIN $myDB->FORMATE ON fi.FORMATE_FormatID = FormatID AND FormatID = $myVar->FormatID";
        if (  $myVar->CollectID != 0 )
            $sql .= " INNER JOIN $myDB->COLLECT ON fi.COLLECT_CollectID = CollectID AND CollectID = $myVar->CollectID";
        if (  $myVar->AudioID != 0 )
            $sql .= " INNER JOIN $myDB->AUDIO ON fi.AUDIO_AudioID = AudioID AND AudioID = $myVar->AudioID";

        $sql .= " WHERE hatThumbnail=1 AND " . $myDB->sqlForPriv;
        $sql .= " GROUP BY fu.FILME_FilmID ";
        $sql .= " ORDER BY Bewertung DESC LIMIT $settings->anzBestFilme";
        
        $rs = $myDB->go($sql);
        for ( $i=0; $row = $myDB->getRow($rs); ++$i )
        {
            $vars = array();
            $vars['MenuID'] = 280;
            $vars['FilmID'] = $row['FilmID'];
            $vars = $myVar->getRequest($vars);
            
            echo "<a title=\"{$row['Titel']}\" class=\"filmThumb\" href=\"{$_SERVER['PHP_SELF']}?$vars\">";
            echo "<img src=\"$cover_dir/{$row['FILME_FilmID']}_{$row['Rang']}_{$row['Appendix']}_small.{$row['Extension']}\" alt=\"cover\" title=\"{$row['Titel']}\" />";
            echo "</a>";
        }
        echo "<div style=\"margin:2em\"></div>";
    }
}


?>
