<?php

/*******************************************
 *                                         *
 *     Filmverwaltung mit PHP & MySQL      *
 *                                         *
 *******************************************
 *                                         *
 * Copyright: ab 2005 Dominik Erdmann      *
 *  Internet: www.der-domi.de              *
 *     Email: kontakt@der-domi.de          *
 *                                         *
 *******************************************
 *                                         *
 * Das Skript darf nach eigenem Belieben   *
 * gendert werden. Copyright-Hinweise und *
 * Links auf www.der-domi.de drfen nicht  *
 * verndert werden und mssen jederzeit   *
 * sichtbar bleiben!                       *
 *                                         *
 *******************************************
 */

/*
 * Statistik ausgeben
 */


if ( $_SESSION['UserRechte'] < 300 )
    exit();

if ( $myVar->MenuID == 292 && $_SESSION['UserRechte'] > 0 )
{
    // Alle Filme ausgeben
    $sql = "SELECT COUNT(*) AS AnzFilme FROM $myDB->FILME fi WHERE ".$myDB->sqlForPriv;
    $rs = $myDB->go($sql);
    $row = $myDB->getRow($rs);
    $anzFilme = $row['AnzFilme'];
    $sql = "SELECT COUNT(DiscID) AS anzDisks FROM $myDB->DISCS INNER JOIN $myDB->FILME fi ON FILME_FilmID=FilmID WHERE".$myDB->sqlForPriv;
    $rs = $myDB->go($sql);
    $row = $myDB->getRow($rs);
    $anzDisks = $row['anzDisks'];
    
    echo "<h2 style=\"padding-left:3em\">$anzFilme Filme auf $anzDisks Disks</h2>";
    
    // wenn keine Filme vorhanden sind, darf nicht durch 0 geteilt werden!
    if ( !$anzFilme )
        ++$anzFilme;
    
    echo "<table>";
    
    // Gesamtzeit ausgeben
    $sql = "SELECT SUM(Laufzeit) AS Sum FROM $myDB->FILME fi WHERE ".$myDB->sqlForPriv;
    $rs = $myDB->go($sql);
    $row = $myDB->getRow($rs);
    echo "<tr>";
    echo "<td class=\"description\">Gesamtzeit aller Filme</td>";
    $tage = floor( $row['Sum']/(24*60));
    $stunden = floor($row['Sum']/60) - $tage*24;
    $min = $row['Sum']-$tage*24*60-$stunden*60;
    //echo "<td>".(int)$row['Sum']."<span style=\"padding-left:0.1em\">min</span> = $tage<span style=\"padding-left:0.1em\">d</span> $stunden<span style=\"padding-left:0.1em\">h</span> $min<span style=\"padding-left:0.1em\">min</span></td>";
    echo "<td>".(int)$row['Sum']." min = $tage d $stunden h $min min</td>";
    echo "</tr>";
    
    $sql = "SELECT AVG(Laufzeit) AS Avg, STDDEV(Laufzeit) AS STD FROM $myDB->FILME fi WHERE fi.Laufzeit > 0 AND ".$myDB->sqlForPriv;
    $rs = $myDB->go($sql);
    $row = $myDB->getRow($rs);
    echo "<tr>";
    echo "<td class=\"description\">Filml&auml;ngen &oslash;</td>";
    echo "<td>". round($row['Avg'], 1)."<span style=\"padding-left:0.1em\">min</span>";
    echo "<span style=\"padding-left:1em; font-size:0.85em\">Standardabweichung: ".(int)$row['STD']." min</span></td>";
    echo "</tr>";
    
    $sql = "SELECT AVG(Jahr) AS Avg, STDDEV(Jahr) AS STD FROM $myDB->FILME fi WHERE LENGTH(Jahr) AND FSKunbekannt=0 AND ".$myDB->sqlForPriv;
    $rs = $myDB->go($sql);
    $row = $myDB->getRow($rs);
    echo "<tr>";
    echo "<td class=\"description\">Filmjahres &oslash;</td>";
    echo "<td>".(int)$row['Avg'];
    echo "<span style=\"padding-left:1em; font-size:0.85em\">Standardabweichung: ".round($row['STD'],1)." Jahre</span></td>";
    echo "</tr>";
    
    $sql = "SELECT AVG(FSK) AS Avg, STDDEV(FSK) AS STD FROM $myDB->FILME fi WHERE ".$myDB->sqlForPriv;
    $rs = $myDB->go($sql);
    $row = $myDB->getRow($rs);
    echo "<tr>";
    echo "<td class=\"description\">FSK &oslash;</td>";
    echo "<td>".round($row['Avg'],1)." Jahre";
    echo "<span style=\"padding-left:1em; font-size:0.85em\">Standardabweichung: ".round($row['STD'],1)." Jahre</span></td>";
    echo "</tr>";
    
    echo "<tr>";
    echo "<td class=\"description\"></td>";
    echo "<td>&nbsp;</td>";
    echo "</tr>";
    
    
    // Formate anzeigen
    if ( $settings->showFormat || $settings->adminSeeAll && $_SESSION['UserRechte'] != 300 )
    {
        echo "<tr>";
        echo "<td></td><td colspan=\"2\" style=\"font-style:italic\">Formate</td>";
        echo "</tr>";
        
        if ( $_SESSION['UserRechte'] <= 600 )
            $sql = "SELECT FormatID, Bezeichnung FROM $myDB->FORMATE WHERE brauchtPrivileg <= {$_SESSION['FormatPrivileg']} ORDER BY Bezeichnung";
        else
            $sql = "SELECT FormatID, Bezeichnung FROM $myDB->FORMATE ORDER BY Bezeichnung";
        $rs = $myDB->go($sql);
        while ( $row = $myDB->getRow($rs) )
        {
            $sql2 = "SELECT COUNT(*) AS AnzFilme FROM $myDB->FILME fi WHERE FORMATE_FormatID={$row['FormatID']} AND ".$myDB->sqlForPriv;
            $rs2 = $myDB->go($sql2);
            $row2 = $myDB->getRow($rs2);
            $percent = round( $row2['AnzFilme'] / $anzFilme, 3 ) * 100;
            
            $sql3 = "SELECT COUNT(DiscID) AS anzDisks FROM $myDB->DISCS INNER JOIN $myDB->FILME fi ON FILME_FilmID=FilmID WHERE FORMATE_FormatID={$row['FormatID']} AND ".$myDB->sqlForPriv;
            $rs3 = $myDB->go($sql3);
            $row3 = $myDB->getRow($rs3);
            $anzDisks = $row3['anzDisks'];
            
            echo "<tr>";
            echo "<td class=\"description\">{$row['Bezeichnung']}</td>";
            echo "<td>";
            switch($row2['AnzFilme'])
            {
                case 0: echo "keine Filme"; break;
                case 1: echo "ein Film"; break;
                default: echo $row2['AnzFilme']." Filme";
            }
            echo ": entspricht $percent % ($anzDisks Disks)</td>";
            echo "</tr>";
            
            // Gesamtzeit ausgeben
            $sql2 = "SELECT SUM(Laufzeit) AS Sum FROM $myDB->FILME fi WHERE FORMATE_FormatID={$row['FormatID']} AND ".$myDB->sqlForPriv;
            $rs2 = $myDB->go($sql2);
            $row2 = $myDB->getRow($rs2);
            echo "<tr>";
            echo "<td></td>";
            $tage = floor( $row2['Sum']/(24*60));
            $stunden = floor($row2['Sum']/60) - $tage*24;
            $min = $row2['Sum']-$tage*24*60-$stunden*60;
            echo "<td>".(int)$row2['Sum']." min = $tage d $stunden h $min min</td>";
            echo "</tr>";
            
            // Filmlngendurchschnitt
            $sql2 = "SELECT AVG(Laufzeit) AS Avg, STDDEV(Laufzeit) AS STD FROM $myDB->FILME fi WHERE FORMATE_FormatID={$row['FormatID']} AND fi.Laufzeit > 0 AND ".$myDB->sqlForPriv;
            $rs2 = $myDB->go($sql2);
            $row2 = $myDB->getRow($rs2);
            echo "<tr>";
            echo "<td></td>";
            echo "<td>". round($row2['Avg'], 1)."<span style=\"padding-left:0.1em\">min</span>";
            echo "<span style=\"padding-left:1em; font-size:0.85em\">Standardabweichung: ".(int)$row2['STD']." min</span></td>";
            echo "</tr>";
        }
        
    
        echo "<tr>";
        echo "<td class=\"description\"></td>";
        echo "<td>&nbsp;</td>";
        echo "</tr>";
    }
    
    // Kollektionen anzeigen
    if ( $settings->showCollect || $settings->adminSeeAll && $_SESSION['UserRechte'] != 300 )
    {
        echo "<tr>";
        echo "<td></td><td colspan=\"2\" style=\"font-style:italic\">Kollektionen</td>";
        echo "</tr>";
        
        if ( $_SESSION['UserRechte'] <= 600 )
            $sql = "SELECT CollectID, Bezeichnung FROM $myDB->COLLECT WHERE brauchtPrivileg <= {$_SESSION['CollectPrivileg']} ORDER BY Bezeichnung";
        else
            $sql = "SELECT CollectID, Bezeichnung FROM $myDB->COLLECT ORDER BY Bezeichnung";
        $rs = $myDB->go($sql);
        while ( $row = $myDB->getRow($rs) )
        {
            $sql2 = "SELECT COUNT(*) AS AnzFilme FROM $myDB->FILME fi WHERE COLLECT_CollectID={$row['CollectID']} AND ".$myDB->sqlForPriv;
            $rs2 = $myDB->go($sql2);
            $row2 = $myDB->getRow($rs2);
            $percent = round( $row2['AnzFilme'] / $anzFilme, 3 ) * 100;
            
            $sql3 = "SELECT COUNT(DiscID) AS anzDisks FROM $myDB->DISCS INNER JOIN $myDB->FILME fi ON FILME_FilmID=FilmID WHERE COLLECT_CollectID={$row['CollectID']} AND ".$myDB->sqlForPriv;
            $rs3 = $myDB->go($sql3);
            $row3 = $myDB->getRow($rs3);
            $anzDisks = $row3['anzDisks'];
            
            echo "<tr>";
            echo "<td class=\"description\">{$row['Bezeichnung']}</td>";
            echo "<td>";
            switch($row2['AnzFilme'])
            {
                case 0: echo "keine Filme"; break;
                case 1: echo "ein Film"; break;
                default: echo $row2['AnzFilme']." Filme";
            }
            echo ": entspricht $percent % ($anzDisks Disks)</td>";
            echo "</tr>";
            
            // Gesamtzeit ausgeben
            $sql2 = "SELECT SUM(Laufzeit) AS Sum FROM $myDB->FILME fi WHERE COLLECT_CollectID={$row['CollectID']} AND ".$myDB->sqlForPriv;
            $rs2 = $myDB->go($sql2);
            $row2 = $myDB->getRow($rs2);
            echo "<tr>";
            echo "<td></td>";
            $tage = floor( $row2['Sum']/(24*60));
            $stunden = floor($row2['Sum']/60) - $tage*24;
            $min = $row2['Sum']-$tage*24*60-$stunden*60;
            echo "<td>".(int)$row2['Sum']." min = $tage d $stunden h $min min</td>";
            echo "</tr>";
            
            // Filmlngendurchschnitt
            $sql2 = "SELECT AVG(Laufzeit) AS Avg, STDDEV(Laufzeit) AS STD FROM $myDB->FILME fi WHERE COLLECT_CollectID={$row['CollectID']} AND fi.Laufzeit > 0 AND ".$myDB->sqlForPriv;
            $rs2 = $myDB->go($sql2);
            $row2 = $myDB->getRow($rs2);
            echo "<tr>";
            echo "<td></td>";
            echo "<td>". round($row2['Avg'], 1)." min";
            echo "<span style=\"padding-left:1em; font-size:0.85em\">Standardabweichung: ".(int)$row2['STD']." min</span></td>";
            echo "</tr>";
        }
        
    
        echo "<tr>";
        echo "<td class=\"description\"></td>";
        echo "<td>&nbsp;</td>";
        echo "</tr>";
    }


    // Audio anzeigen
    if ( $settings->showAudio || $settings->adminSeeAll && $_SESSION['UserRechte'] != 300 )
    {
        echo "<tr>";
        echo "<td></td><td colspan=\"2\" style=\"font-style:italic\">Audioformate</td>";
        echo "</tr>";
        
        if ( $_SESSION['UserRechte'] <= 600 )
            $sql = "SELECT AudioID, Bezeichnung FROM $myDB->AUDIO WHERE brauchtPrivileg <= {$_SESSION['AudioPrivileg']} ORDER BY Bezeichnung";
        else
            $sql = "SELECT AudioID, Bezeichnung FROM $myDB->AUDIO ORDER BY Bezeichnung";
        $rs = $myDB->go($sql);
        while ( $row = $myDB->getRow($rs) )
        {
            $sql2 = "SELECT COUNT(*) AS AnzFilme FROM $myDB->FILME fi WHERE AUDIO_AudioID={$row['AudioID']} AND ".$myDB->sqlForPriv;
            $rs2 = $myDB->go($sql2);
            $row2 = $myDB->getRow($rs2);
            $percent = round( $row2['AnzFilme'] / $anzFilme, 3 ) * 100;
            
            $sql3 = "SELECT COUNT(DiscID) AS anzDisks FROM $myDB->DISCS INNER JOIN $myDB->FILME fi ON FILME_FilmID=FilmID WHERE AUDIO_AudioID={$row['AudioID']} AND ".$myDB->sqlForPriv;
            $rs3 = $myDB->go($sql3);
            $row3 = $myDB->getRow($rs3);
            $anzDisks = $row3['anzDisks'];
            
            echo "<tr>";
            echo "<td class=\"description\">{$row['Bezeichnung']}</td>";
            echo "<td>";
            switch($row2['AnzFilme'])
            {
                case 0: echo "keine Filme"; break;
                case 1: echo "ein Film"; break;
                default: echo $row2['AnzFilme']." Filme";
            }
            echo ": entspricht $percent % ($anzDisks Disks)</td>";
            echo "</tr>";
            
            // Gesamtzeit ausgeben
            $sql2 = "SELECT SUM(Laufzeit) AS Sum FROM $myDB->FILME fi WHERE AUDIO_AudioID={$row['AudioID']} AND ".$myDB->sqlForPriv;
            $rs2 = $myDB->go($sql2);
            $row2 = $myDB->getRow($rs2);
            echo "<tr>";
            echo "<td></td>";
            $tage = floor( $row2['Sum']/(24*60));
            $stunden = floor($row2['Sum']/60) - $tage*24;
            $min = $row2['Sum']-$tage*24*60-$stunden*60;
            echo "<td>".(int)$row2['Sum']." min = $tage d $stunden h $min min</td>";
            echo "</tr>";
            
            // Filmlngendurchschnitt
            $sql2 = "SELECT AVG(Laufzeit) AS Avg, STDDEV(Laufzeit) AS STD FROM $myDB->FILME fi WHERE AUDIO_AudioID={$row['AudioID']} AND fi.Laufzeit > 0 AND ".$myDB->sqlForPriv;
            $rs2 = $myDB->go($sql2);
            $row2 = $myDB->getRow($rs2);
            echo "<tr>";
            echo "<td></td>";
            echo "<td>". round($row2['Avg'], 1)." min";
            echo "<span style=\"padding-left:1em; font-size:0.85em\">Standardabweichung: ".(int)$row2['STD']." min</span></td>";
            echo "</tr>";
        }
        
    
        echo "<tr>";
        echo "<td class=\"description\"></td>";
        echo "<td>&nbsp;</td>";
        echo "</tr>";
    }
    
    
    // Anzahl aller Schauspieler und Regisseuren
    if ( $myDB->MySQL_Ver )
        $sql = "SELECT COUNT(*) AS Anz FROM $myDB->REGISSEURE re WHERE re.RegisseurID IN( SELECT REGISSEURE_RegisseurID FROM $myDB->FILME_REGISSEURE fr INNER JOIN $myDB->FILME fi ON fr.FILME_FilmID=fi.FilmID WHERE $myDB->sqlForPriv )";
    else
        $sql = "SELECT COUNT(*) AS Anz FROM $myDB->REGISSEURE";
    $rs = $myDB->go($sql);
    $row = $myDB->getRow($rs);
    $anzRegisseure = $row['Anz'];
    echo "<tr>";
    echo "<td class=\"description\">Anzahl aller Regisseure</td>";
    echo "<td>".$row['Anz']."</td>";
    echo "</tr>";
    
    if ( $myDB->MySQL_Ver )
        $sql = "SELECT DISTINCT COUNT(*) AS Anz FROM $myDB->ACTORS re WHERE re.ActorID IN( SELECT ACTORS_ActorID FROM $myDB->FILME_ACTORS fa INNER JOIN $myDB->FILME fi ON fa.FILME_FilmID=fi.FilmID WHERE $myDB->sqlForPriv )";
    else
        $sql = "SELECT COUNT(*) AS Anz FROM $myDB->ACTORS";
    $rs = $myDB->go($sql);
    $row = $myDB->getRow($rs);
    $anzActors = $row['Anz'];
    echo "<tr>";
    echo "<td class=\"description\">Anzahl aller Schauspieler</td>";
    echo "<td>".$row['Anz']."</td>";
    echo "</tr>";
    
    echo "<tr>";
    echo "<td class=\"description\"></td>";
    echo "<td>&nbsp;</td>";
    echo "</tr>";
    

    // Schauspieler / Regisseure in allen Filmen
    if ( $myDB->MySQL_Ver )
        $sql = "SELECT COUNT(*) AS Anz FROM $myDB->FILME_ACTORS fa WHERE fa.FILME_FilmID IN ( SELECT FilmID FROM $myDB->FILME fi WHERE $myDB->sqlForPriv )";
    else
        $sql = "SELECT COUNT(*) AS Anz FROM $myDB->FILME_ACTORS";
    $rs = $myDB->go($sql);
    $row = $myDB->getRow($rs);
    echo "<tr>";
    echo "<td class=\"description\">Schauspieler in allen Filmen</td>";
    echo "<td>".$row['Anz']."</td>";
    echo "</tr>";
    $anzFilmActors = $row['Anz'];
    
    echo "<tr>";
    echo "<td class=\"description\">Schauspieler pro Film &oslash;</td>";
    echo "<td>".round( $anzFilmActors/$anzFilme, 1 )."</td>";
    echo "</tr>";
    
    if ( $myDB->MySQL_Ver )
        $sql = "SELECT COUNT(*) AS Anz FROM $myDB->FILME_REGISSEURE fr WHERE fr.FILME_FilmID IN ( SELECT FilmID FROM $myDB->FILME fi WHERE $myDB->sqlForPriv )";
    else
        $sql = "SELECT COUNT(*) AS Anz FROM $myDB->FILME_REGISSEURE";
    $rs = $myDB->go($sql);
    $row = $myDB->getRow($rs);
    echo "<tr>";
    echo "<td class=\"description\">Regisseure von allen Filmen</td>";
    echo "<td>".$row['Anz']."</td>";
    echo "</tr>";
    $anzFilmRegie = $row['Anz'];
    
    echo "<tr>";
    echo "<td class=\"description\">Regisseure pro Film &oslash;</td>";
    echo "<td>".round( $anzFilmRegie/$anzFilme, 2 )."</td>";
    echo "</tr>";
    
    echo "<tr>";
    echo "<td class=\"description\"></td>";
    echo "<td>&nbsp;</td>";
    echo "</tr>";
    
    if ( $myDB->MySQL_Ver )
    {
        if ( $anzActors )
        {
            // Dieses Query geht bestimmt noch einfacher!
            $sql = "SELECT MAX(Anz) AS Max, temp.ACTORS_ActorID FROM ( SELECT ACTORS_ActorID, COUNT(*) AS Anz FROM $myDB->FILME_ACTORS fa INNER JOIN $myDB->FILME fi ON fa.FILME_FilmID=fi.FilmID WHERE $myDB->sqlForPriv GROUP BY ACTORS_ActorID) temp GROUP BY temp.Anz ORDER BY Max DESC";
            $rs = $myDB->go($sql);
            $row = $myDB->getRow($rs);
            $sql2 = "SELECT * FROM $myDB->ACTORS WHERE ActorID = {$row['ACTORS_ActorID']}";
            $rs2 = $myDB->go($sql2);
            $row2 = $myDB->getRow($rs2);
            echo "<tr>";
            echo "<td class=\"description\">h&auml;ufigster Schauspieler</td>";
            echo "<td><a href=\"{$_SERVER['PHP_SELF']}?MenuID=290&amp;ActorID={$row['ACTORS_ActorID']}\">{$row2['Name']}</a> spielt in {$row['Max']} Filmen mit</td>";
            echo "</tr>";
        }
        
        // wenn anzFilme==0, wird counter inkrementiert, um division durch null zu verhindern! 
        if ( $anzFilme != 1 && $anzActors )
        {
            // Dieses Query geht bestimmt noch einfacher!
            $sql = "SELECT MAX(Anz) AS Max, temp.FILME_FilmID FROM ( SELECT FILME_FilmID, COUNT(*) AS Anz FROM $myDB->FILME_ACTORS fa INNER JOIN $myDB->FILME fi ON fa.FILME_FilmID=fi.FilmID WHERE $myDB->sqlForPriv GROUP BY FILME_FilmID) temp GROUP BY temp.Anz ORDER BY Max DESC";
            $rs = $myDB->go($sql);
            $row = $myDB->getRow($rs);
            $sql2 = "SELECT Titel FROM $myDB->FILME WHERE FilmID = {$row['FILME_FilmID']}";
            $rs2 = $myDB->go($sql2);
            $row2 = $myDB->getRow($rs2);
            echo "<tr>";
            echo "<td class=\"description\">meisten Schauspieler</td>";
            echo "<td>in <a href=\"{$_SERVER['PHP_SELF']}?MenuID=280&amp;FilmID={$row['FILME_FilmID']}\">{$row2['Titel']}</a> spielen {$row['Max']} Schauspieler mit</td>";
            echo "</tr>";
        }
        
        if ( $anzRegisseure )
        {
            // Dieses Query geht bestimmt noch einfacher!
            $sql = "SELECT MAX(Anz) AS Max, temp.REGISSEURE_RegisseurID FROM ( SELECT REGISSEURE_RegisseurID, COUNT(*) AS Anz FROM $myDB->FILME_REGISSEURE fr INNER JOIN $myDB->FILME fi ON fr.FILME_FilmID=fi.FilmID WHERE $myDB->sqlForPriv GROUP BY REGISSEURE_RegisseurID) temp GROUP BY temp.Anz ORDER BY Max DESC";
            $rs = $myDB->go($sql);
            $row = $myDB->getRow($rs);
            $sql2 = "SELECT * FROM $myDB->REGISSEURE WHERE RegisseurID = {$row['REGISSEURE_RegisseurID']}";
            $rs2 = $myDB->go($sql2);
            $row2 = $myDB->getRow($rs2);
            echo "<tr>";
            echo "<td class=\"description\">h&auml;ufigster Regisseur</td>";
            echo "<td><a href=\"{$_SERVER['PHP_SELF']}?MenuID=290&amp;RegisseurID={$row['REGISSEURE_RegisseurID']}\">{$row2['Name']}</a> gibt Regie in {$row['Max']} Filmen</td>";
            echo "</tr>";
        }
    }
    
    echo "</table>";
    
    echo "<p style=\"margin-top:2em;\">Deine Session verursachte bereits <strong>".$_SESSION['db_counter']. "</strong> Datenbankabfragen ;-)</p>";
}




?>
