<?php

/*******************************************
 *                                         *
 *     Filmverwaltung mit PHP & MySQL      *
 *                                         *
 *******************************************
 *                                         *
 * Copyright: ab 2005 Dominik Erdmann      *
 *  Internet: www.der-domi.de              *
 *     Email: kontakt@der-domi.de          *
 *                                         *
 *******************************************
 *                                         *
 * Das Skript darf nach eigenem Belieben   *
 * gendert werden. Copyright-Hinweise und *
 * Links auf www.der-domi.de drfen nicht  *
 * verndert werden und mssen jederzeit   *
 * sichtbar bleiben!                       *
 *                                         *
 *******************************************
 */

/*
 * Installationsskript
 */


// includes
require("../settings/admin.php");
require("../settings/php.php");
require("../classes/class.ctlVar.php");
require("../classes/class.db.php");
require("../classes/class.out.php");
require("../classes/class.phpmailer.php");
require("../classes/class.settings.php");
require("../includes/functions.php");
require("../includes/funcOutput.php");

$myDB  = new db($server, $username, $pass, $dbase, $prefix, $MySQL_Ver);
$out   = new out( "  ", 0 );
$settings = new settings( $myDB, TRUE );
$settings->standardStyle = "../styles/style01.css";
$settings->browserTitel = "Filmverwaltung mit PHP &amp; MySQL";
$myVar = new ctlVar($settings,$myDB,$COOCKIES_ACTIVE,TRUE);


//$myVar->crtlGetPostData( $myDB, $settings );
$out->startBuffer();

if ( isset($_REQUEST['sent']) )
{
    if ( strlen( $_REQUEST['UserName'] ) < 3 )
        $myVar->warnung[] = "Benutzername muss mindestens 3 Zeichen lang sein!";
    elseif ( !preg_match( "/$pregUserName/", $_REQUEST['UserName'], $reg2 ) )
        $myVar->warnung[] = "Ung&uuml;litger Benutzername";
    if ( !preg_match( "/$pregEmail/", strtolower($_REQUEST['Email']), $reg1 ) )
        $myVar->warnung[] = "Ung&uuml;litge Emailadresse!";
    if ( strlen($_REQUEST['PWD']) < 6 )
        $myVar->warnung[] = "Passwort muss mindestens 6 Zeichen lang sein.";
    elseif ( $_REQUEST['PWD'] != $_REQUEST['PWD2'] )
        $myVar->warnung[] = "Passw&ouml;rter stimmen nicht &uuml;berein!";
//    elseif ( strlen($_REQUEST['FormatName']) <= 2 )
//        $warning = mySpace(1)."Ung&uuml;ltiger Formatname. Mindestens drei Zeichen!";
//    elseif ( strlen($_REQUEST['CollectName']) <= 2 )
//        $warning = mySpace(1)."Ung&uuml;ltiger Kollektionsname. Mindestens drei Zeichen!";
    
    if ( !count($myVar->warnung) )
    {
        $email = $reg1[0];
        $Name = $myDB->escape_string( htmlentities( $reg2[0] ) );
        $PWD = $myDB->escape_string( str_replace( " ", "X", $_REQUEST['PWD'] ) );
        //$FormatName = $myDB->escape_string( htmlentities( $_REQUEST['FormatName'] ) );
        //$CollectName = $myDB->escape_string( htmlentities( $_REQUEST['CollectName'] ) );
        
        
        // neue Tabellen erstellen
        $array = file("./install_dabamodell.sql");
        for ( $i = 0; $i < count($array); ++$i )
        {
            $sql = str_replace( "PREFIX_", $prefix, $array[$i] );
            $sql = str_replace( ";", '', $sql );
            $myDB->go($sql);
        }
        
        $settings->reset_settings( $myDB );
        
        $sql = "SELECT COUNT(*) AS Anz FROM $myDB->USERS WHERE UserID = 1";
        $rs = $myDB->go($sql);
        $row = $myDB->getRow($rs);
        if ( $row['Anz'] > 0 )
        {
            $sql = "DELETE FROM $myDB->USERS WHERE UserID=1";
            $rs = $myDB->go($sql);
        }
        $sql = "INSERT INTO $myDB->USERS (UserID, UserName, Email, PWD, UserRechte, FilmPrivileg, FormatPrivileg, GenrePrivileg, anzLogin, getEmail, Style) VALUES (1, $Name, '$email', PASSWORD($PWD), 900, 1, 1, 1, 0, 0, 'style01.css')";
        $rs = $myDB->go($sql);
        
        $sql = "SELECT COUNT(*) AS Anz FROM $myDB->FORMATE WHERE FormatID = 1";
        $rs = $myDB->go($sql);
        $row = $myDB->getRow($rs);
        if ( $row['Anz'] == 0 )
        {
            $sql = "INSERT INTO $myDB->FORMATE (FormatID, Bezeichnung, istStandard, brauchtPrivileg) VALUES (1, 'DVD', 1, 1)";
            $rs = $myDB->go($sql);
        }
        $sql = "SELECT COUNT(*) AS Anz FROM $myDB->COLLECT WHERE CollectID = 1";
        $rs = $myDB->go($sql);
        $row = $myDB->getRow($rs);
        if ( $row['Anz'] == 0 )
        {
            $sql = "INSERT INTO $myDB->COLLECT (CollectID, Bezeichnung, istStandard, brauchtPrivileg) VALUES (1, 'Kinofilme', 1, 1)";
            $rs = $myDB->go($sql);
        }
        $sql = "SELECT COUNT(*) AS Anz FROM $myDB->AUDIO WHERE AudioID = 1";
        $rs = $myDB->go($sql);
        $row = $myDB->getRow($rs);
        if ( $row['Anz'] == 0 )
        {
            $sql = "INSERT INTO $myDB->AUDIO (AudioID, Bezeichnung, istStandard, brauchtPrivileg) VALUES (1, 'Stereo', 1, 1)";
            $rs = $myDB->go($sql);
        }
        $sql = "SELECT COUNT(*) AS Anz FROM $myDB->GENRES WHERE GenreID = 1";
        $rs = $myDB->go($sql);
        $row = $myDB->getRow($rs);
        if ( $row['Anz'] == 0 )
        {
            $sql = "INSERT INTO $myDB->GENRES (GenreID, Name) VALUES (1, 'mein Genre')";
            $rs = $myDB->go($sql);
        }
        
        $cover_dir_tmp = $_SERVER['SCRIPT_FILENAME'];
        $cover_dir_tmp = str_replace( "install/install.php", "", $cover_dir_tmp );
        $cover_dir_tmp .= $cover_dir;
        
        // das Verzeichnis 'covers' muss beschreibbar sein
        if ( FALSE == is_writable($cover_dir_tmp) )
        {
            if ( !chmod( "$cover_dir_tmp", 0777 ) )
                $myVar->hinweis[] = "Es konnten keine Schreibrechte f&uuml;r das Verzeichnis &quot;$cover_dir&quot; vergeben werden. Evtl. k&ouml;nnen keine Cover importiert werden. Pr&uuml;fe die Rechte (Modus 0775 oder 0777) &uuml;ber den FTP-Zugang!";
        }
        
        if ( !$gdlib )
        {
            $myVar->warnung[] = "Deiner PHP-Installation fehlt gdlib zum Erstellen von Thumbnails.";
            
            /*
            $sql = "UPDATE $myDB->SETTINGS SET Wert=\"0\" WHERE Variable=\"anzTopFilme\"";
            $rs = $myDB->go($sql);
            $sql = "UPDATE $myDB->SETTINGS SET Wert=\"0\" WHERE Variable=\"anzNeueFilme\"";
            $rs = $myDB->go($sql);
            $sql = "UPDATE $myDB->SETTINGS SET Wert=\"0\" WHERE Variable=\"anzBestFilme\"";
            $rs = $myDB->go($sql);
            */
        }
    }
    
    
    if ( count( $myVar->warnung ) )
        unset($_REQUEST['sent']);
}


// Hier werden Ausgaben fr das Men gemacht
printHeader( $settings );
echo "<div id=\"seite\">";
printTopLogin( $myVar, $settings );


echo "<div id=\"untermenu\">";
echo "<ul>";
echo "<li>";
echo "<a href=\"../\">zum Loginformular</a>";
echo "</li>";
echo "</ul>";
echo "</div>";


if ( count( $myVar->warnung ) )
{
    echo "<ul class=\"message\" style=\"background-color:#f88\">";
    for ( $i=0; $i<count( $myVar->warnung ); ++$i )
        echo "<li>".$myVar->warnung[$i]."</li>";
    echo "</ul>";
}

if ( count( $myVar->hinweis ) )
{
    echo "<ul class=\"message\" style=\"background-color:#ffa\">";
    for ( $i=0; $i<count( $myVar->hinweis ); ++$i )
        echo "<li>".$myVar->hinweis[$i]."</li>";
    echo "</ul>";
}


echo "<div id=\"inhalt\">";

if ( !isset($_REQUEST['sent']) || count( $myVar->warnung ) )
{
    echo "<p>Zuerst <a href=\"../docs/Filmverwaltung_Handbuch.pdf\">Handbuch</a> lesen!</p>";
    echo "<p><strong>Zur Erinnerung</strong>: Wurde die Datei admin.php bearbeitet? Wurde die Datenbank erstellt?</p>";
    $sql = "SELECT VERSION() AS version";
    $rs = $myDB->go($sql);
    $row = $myDB->getRow($rs);
    echo "<p>MySQL-Version ist: ".$row['version'];
    if ( (float)$row['version'] < 4.1 )
        echo "<br />Es scheint so, als ob es eine alte Version ist. Beachte den Eintrag in der Datei 'admin.php'! Sonst kommt es zu Fehlermeldungen.";
    echo "</p>";
    echo "<p>Um zu dem Loginformular zu gelangen, m&uuml;ssen zuerst die Tabellen erstellt werden.</p>";
    echo "<form method=\"post\" action=\"{$_SERVER['PHP_SELF']}\">";
    echo "<table>";
    echo "<tr>";
    echo "<td colspan=\"2\" style=\"padding:0em 0 1em 0;font-weight:bold;font-size:0.9em\">Hier die Benutzerdaten des Admins</td>";
    echo "</tr>";
    echo "<tr>";
    echo "<td class=\"description\">Name</td>";
    echo "<td><input type=\"text\" name=\"UserName\" value=\"";
    if ( array_key_exists('UserName',$_POST) )
        echo $_REQUEST['UserName'];
    echo "\" size=\"25\" /></td>";
    echo "</tr>";
    echo "<tr>";
    echo "<td class=\"description\">Email</td>";
    echo "<td><input type=\"text\" name=\"Email\" value=\"";
    if ( array_key_exists('Email',$_POST) )
        echo $_REQUEST['Email'];
    echo "\" size=\"25\" /></td>";
    echo "</tr>";
    echo "<tr>";
    echo "<td class=\"description\">Passwort</td>";
    echo "<td><input type=\"password\" name=\"PWD\" size=\"25\" /></td>";
    echo "</tr>";
    echo "<tr>";
    echo "<td class=\"description\">Wiederholung</td>";
    echo "<td><input type=\"password\" name=\"PWD2\" size=\"25\" /></td>";
    echo "</tr>";
    /*
    echo mySpace(3)."<tr>";
    echo mySpace(4)."<td colspan=\"2\" style=\"padding:2em 0 1em 0;font-weight:bold;font-size:0.9em\">Wichtig: Es muss ein Format und eine Kollektion als Standard eingetragen werden</td>";
    echo mySpace(3)."</tr>";
    echo mySpace(3)."<tr>";
    echo mySpace(4)."<td class=\"description\">Format</td>";
    echo mySpace(4)."<td><input type=\"text\" name=\"FormatName\" value=\"{$_REQUEST['FormatName']}\" size=\"25\" /></td>";
    echo mySpace(3)."</tr>";
    echo mySpace(3)."<tr>";
    echo mySpace(4)."<td class=\"description\">Kollektion</td>";
    echo mySpace(4)."<td><input type=\"text\" name=\"CollectName\" value=\"{$_REQUEST['CollectName']}\" size=\"25\" /></td>";
    echo mySpace(3)."</tr>";
    echo mySpace(3)."<tr>";
    echo mySpace(4)."<td class=\"description\">Audio</td>";
    echo mySpace(4)."<td><input type=\"text\" name=\"AudioName\" value=\"{$_REQUEST['AudioName']}\" size=\"25\" /></td>";
    echo mySpace(3)."</tr>";
    */
    echo "</table>";
    echo "<p><input type=\"hidden\" name=\"sent\" value=\"1\" /></p>";
    echo "<p style=\"margin-top:2em\"><input class=\"buttonSubmit\" type=\"submit\" name=\"sent\" value=\"senden\" /></p>";
    echo "</form>";
}
else
{
    echo "<p>Falls kein Fehler aufgetreten ist:</p>";
    echo "<h2>INSTALLATIONSVERZEICHNIS VOM SERVER L&Ouml;SCHEN! Bei einem erneuten Ausf&uuml;hren des Skriptes wird der Administratoreintrag ge&auml;ndert!</h2>";
}

echo "</div>";
/* 
 * COPYRIGHT-HINWEISE DRFEN NICHT VERNDERT WERDEN!
 * LINKS AUF WWW.DER-DOMI.DE MSSEN BESTEHEN BLEIBEN!
 */
printFootline($settings);
echo "</div>";
echo "</body></html>";


$out->put( $out->endBuffer() );


?>
